# File procdata/Src/t_cleanstr.x
# September 12, 2005
# By Doug Mink, Center for Astrophysics

# T_CLEANSTR -- Replace bad characters in a string with _
# Replace - (minus sign) with m
# Drop trailing underscores
# The string is returned as a CL parameter of type string

procedure t_cleanstr ()

pointer	sp
pointer	value
char	badchars[SZ_LINE]
bool	vb, clgetb()
int	i, lstr, strlen(), stridx()

begin
	call smark (sp)
	call salloc (value, SZ_LINE,  TY_CHAR)
	
	call clgstr ("invalue", Memc[value], SZ_LINE)
	call strcpy (",!;&()[]{}@|\\#$%:<>?*\"\'", badchars, SZ_LINE)

	vb = clgetb ("verbose")

# Replace bad characters with underscores
	lstr = strlen (Memc[value])
	if (lstr > SZ_LINE - 1)
	    lstr = SZ_LINE - 1
	for (i = 0; i < lstr; i = i + 1) {
	    if (stridx (Memc[value+i], badchars) > 0)
		Memc[value+i] = '_'
	    if (Memc[value+i] == '-')
		Memc[value+i] = 'm'
	    }
	if (Memc[value+lstr - 1] == '_') {
	    Memc[value+lstr - 1] = EOS
	    if (Memc[value+lstr - 2] == '_') {
		Memc[value+lstr - 2] = EOS
		}
	    }

	call clpstr ("value", Memc[value])
	if (vb) {
	    call printf ("%s\n")
		call pargstr (Memc[value])
	    }
	call sfree (sp)
end

# Sep 12 2005	New IRAF task
